/*
 * This file is a part of the SteamWar software.
 *
 * Copyright (C) 2023  SteamWar.de-Serverteam
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.sql;

import de.steamwar.sql.internal.Field;
import de.steamwar.sql.internal.SelectStatement;
import de.steamwar.sql.internal.Statement;
import de.steamwar.sql.internal.Table;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.Setter;

import java.util.HashMap;
import java.util.Map;

@AllArgsConstructor
public class PollAnswer {

    @Getter
    @Setter
    private static String currentPoll;

    private static final Table<PollAnswer> table = new Table<>(PollAnswer.class);

    private static final SelectStatement<PollAnswer> get = table.select(Table.PRIMARY);
    private static final Statement getResults = new Statement("SELECT Count(UserID) AS Times, Answer FROM PollAnswer WHERE Question = ? GROUP BY Answer ORDER BY Times ASC");
    private static final Statement insert = table.insertAll();

    @Field(keys = {Table.PRIMARY})
    private final int userID;
    @Field(keys = {Table.PRIMARY})
    private final String question;
    @Field(def = "0")
    private int answer;

    public static PollAnswer get(int userID) {
        PollAnswer answer = get.select(userID, currentPoll);
        if(answer == null)
            return new PollAnswer(userID, currentPoll, 0);
        return answer;
    }

    public static Map<Integer, Integer> getCurrentResults() {
        return getResults.select(rs -> {
            Map<Integer, Integer> retMap = new HashMap<>();
            while (rs.next())
                retMap.put(rs.getInt("Answer")-1, rs.getInt("Times"));
            return retMap;
        }, currentPoll);
    }

    public boolean hasAnswered(){
        return answer != 0;
    }

    public void setAnswer(int answer){
        this.answer = answer;
        insert.update(userID, question, answer);
    }
}
